#include<bits/stdc++.h>
#define endl '\n'
#define INF 1000005.0
#define START_SPEED 70
using namespace std;
vector<pair<int,pair<int,int>>>graph[205];
double dist[205];
priority_queue<pair<double,int>>dijkstra;
int parent[205],parent_speed[205];
stack<int>path;
int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n,m,s;
	cin>>n>>m>>s;
	for(int i=0;i<m;i++){
		int a,b,v,l;
		cin>>a>>b>>v>>l;
		graph[a].push_back({b,{v,l}});
	}
	for(int i=1;i<n;i++) dist[i]=INF;
	dist[0]=0.0;
	dijkstra.push({-dist[0],0});
	parent_speed[0]=START_SPEED;
	while(!dijkstra.empty()){
		int start_point=dijkstra.top().second;
		dijkstra.pop();
		//cout<<start_point<<" "<<parent[start_point]<<endl;
		for(int i=0;i<graph[start_point].size();i++){
			int end_point=graph[start_point][i].first,speed=graph[start_point][i].second.first,length=graph[start_point][i].second.second;
			if(speed==0) speed=parent_speed[start_point];
			double time=(double)length/speed;
			//cout<<"("<<end_point<<","<<speed<<","<<length<<","<<time<<","<<dist[start_point]<<","<<dist[end_point]<<")\n";
			if(dist[start_point]+time<dist[end_point]){
				dist[end_point]=dist[start_point]+time;
				dijkstra.push({-dist[end_point],end_point});
				parent[end_point]=start_point;
				parent_speed[end_point]=speed;
				//cout<<"("<<end_point<<")\n";
			}
		}
	}
	//cout<<dist[s]<<endl;
	path.push(s);
	int j=parent[s];
	while(j!=0){
		path.push(j);
		j=parent[j];
	}
	cout<<"0 ";
	while(!path.empty()){
		cout<<path.top()<<" ";
		path.pop();
	}
	cout<<endl;
return 0;
}
