#include<iostream>
#include<string>
#include<stack>
#include<map>
using namespace std;

map<char,int> digit;

string convert(string num)
{
    int res=0;
    while(num.size())
    {
        if(num.size()>=2 and digit[num[0]]<digit[num[1]])
        {
            res+=digit[num[1]]-digit[num[0]];
            num.erase(0,2);
        }
        else
        {
            res+=digit[num[0]];
            num.erase(0,1);
        }
    }
    string ret="";
    while(res>0)
    {
        ret+=res%10+'0';
        res/=10;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    digit['I']=1;
    digit['V']=5;
    digit['X']=10;
    digit['L']=50;
    digit['C']=100;
    digit['D']=500;
    digit['M']=1000;

    string s;
    cin >> s;

    int n=s.size();

    string num,expr="";
    int j;
    for(int i=0; i<n; i++)
    {
        if(isalpha(s[i]))
        {
            j=i;
            num="";
            while(isalpha(s[j]))
            {
                num+=s[j];
                j++;
            }
            expr+=convert(num);
            i=j-1;
        }
        else expr+=s[i];
    }

    cout << expr << endl;

    return 0;
}
