#include <bits/stdc++.h>

using namespace std;

#define print(x) cout << #x << " = " << x << endl;
typedef long long ll;
typedef unsigned long long ull;

struct Ans {
    int k;
    double t, v;
    vector<int> pred;
    bool operator <(Ans &other) {
        if(t == other.t)
            return v > other.v;
        return t > other.t;
    }
};

struct Edge {
    int  a, b;
    double v, l;
    bool operator <(Edge other) {
        return other.v * l > other.l * v;
    }
};

struct CMP{
    bool operator ()(Ans a, Ans b) {
        if(a.t == b.t)
            return a.v > b.v;
        return a.t > b.t;
    }
};

Ans ans[200];
vector<Edge> g[200];
int n, m, s;
const double eps = 0.000001;
priority_queue<Ans, vector<Ans>, CMP> k;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m >> s;
    for(int i = 0; i < m; i ++) {
        int a, b, v, l;
        cin >> a >> b >> v >> l;
        g[a].push_back({a, b, v, l});
    }
    for(int i = 0; i < n; i ++) {
        ans[i].k = i;
        ans[i].t = 9999999;
        ans[i].v = 0;
    }
    k.push({0, 0, 70});
    ans[0] = k.top();
    Ans vrans = {s, 10000000, 0};
    while(!k.empty()) {
        Ans curr = k.top();
        k.pop();
        //cout << curr.k << " ";
        if(ans[curr.k].t > curr.t && ans[curr.k].v < curr.v) {
            ans[curr.k] = curr;
        }
        if(curr.k == s && curr.t < vrans.t) {
            vrans = curr;
        }
        for(int i = 0; i < g[curr.k].size(); i ++) {
            double dist, vel;
            if(g[curr.k][i].v < eps) {
                vel = curr.v;
            } else {
                vel = g[curr.k][i].v;
            }
            dist = g[curr.k][i].l / vel;
            if(ans[g[curr.k][i].b].t > curr.t + dist || ans[g[curr.k][i].b].v < vel) {
                Ans q = {g[curr.k][i].b, curr.t + dist, ans[g[curr.k][i].b].v, curr.pred};
                q.pred.push_back(curr.k);
                k.push(q);
           }
        }
    }
    for(int i = 0; i < vrans.pred.size(); i ++) {
        cout << vrans.pred[i] << " ";
    }
    cout << s;

    return 0;
}


/*
6
15
1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
*/
