#include <bits/stdc++.h>

using namespace std;

struct edge {
    int a, b, v, l, na4s;
    double actl, na4t;
    bool operator <(edge other) {
        return this->actl > other.actl;
    }
};

struct CMP{
    bool operator ()(edge a, edge b) {
        return a.actl > b.actl;
    }
};

double best[300][600];
int last[300][600];
int lastv[300][600];
vector<edge> g[300];

int main(){
    int n, m, s;
    cin >> n >> m >> s;
    for(int i = 0; i < m; i ++) {
        int a, b, v, l;
        cin >> a >> b >> v >> l;
        g[a].push_back({a, b, v, l, 0});
    }
    priority_queue<edge, vector<edge>, CMP> k;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < 600; j ++) {
            best[i][j] = 1000000;
            last[i][j] = -1;
        }
    }
    best[0][70] = 0;
    last[0][70] = -1;
    for(int i = 0; i < g[0].size(); i ++) {
        edge curr = g[0][i];
        if(curr.v == 0)
            curr.v = 70;
        curr.actl = curr.l / curr.v;
        best[g[0][i].b][curr.v] = curr.actl;
        lastv[g[0][i].b][curr.v] = curr.v;
        last[g[0][i].b][curr.v] = 0;
        k.push(curr);
    }
    while(!k.empty()) {
        edge t = k.top(); k.pop();
        //cout << t.b << endl;
        for(int i = 0; i < g[t.b].size(); i ++) {
            edge curr = g[t.b][i];
            if(curr.v == 0)
                curr.v = t.v;
            curr.actl = curr.l / curr.v;
            if(best[g[t.b][i].b][curr.v] > best[t.b][curr.v] + curr.actl) {
                best[g[t.b][i].b][curr.v] = curr.actl;
                lastv[g[t.b][i].b][curr.v] = curr.v;
                last[g[t.b][i].b][curr.v] = t.b;
                k.push(curr);
            }
        }
    }
    double mn = 1000000, mni = 0;
    for(int i = 0; i < 600; i ++) {
        if(mn > best[s][i]) {
            //cout << best[s][i] << " " << last[s][i] << " " << endl;
            mni = i;
            mn = best[s][i];
        }
    }

    int currt = s, currv = mni;
    int ncurr = s, ncurrv = mni;

    vector<int> karam;

    while(currt != -1) {
        karam.push_back(currt);
        ncurr = last[currt][currv];
        ncurrv = lastv[currt][currv];
        currt = ncurr;
        currv = ncurrv;
    }
    for(int i = karam.size() - 1; i >= 0; i --)
        cout << karam[i] << " ";

}

/*
4 4 3
0 1 1 1
1 2 1 1
0 2 2 1
2 3 2 1

*/


/*
6
15
1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
*/
