#include <bits/stdc++.h>

using namespace std;

struct edge {
    int a, b, v, l;
    double actl;
    bool operator <(edge other) {
        return this->actl > other.actl;
    }
};

struct CMP{
    bool operator ()(edge a, edge b) {
        return a.actl > b.actl;
    }
};

double best[300][600];
vector<int> put[300][600];
vector<edge> g[300];

int main(){
    int n, m, s;
    cin >> n >> m >> s;
    for(int i = 0; i < m; i ++) {
        int a, b, v, l;
        cin >> a >> b >> v >> l;
        g[a].push_back({a, b, v, l, 0});
    }
    priority_queue<edge, vector<edge>, CMP> k;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < 600; j ++) {
            best[i][j] = 1000000;
        }
    }
    best[0][70] = 0;
    for(int i = 0; i < g[0].size(); i ++) {
        edge curr = g[0][i];
        if(curr.v == 0)
            curr.v = 70;
        curr.actl = ((double)curr.l) / ((double)curr.v);
        best[g[0][i].b][curr.v] = curr.actl;
        put[g[0][i].b][curr.v].push_back(0);
        k.push(curr);
    }
    while(!k.empty()) {
        edge t = k.top(); k.pop();
        //cout << t.b << endl;
        for(int i = 0; i < g[t.b].size(); i ++) {
            edge curr = g[t.b][i];
            if(curr.v == 0)
                curr.v = t.v;
            curr.actl = ((double)curr.l) / ((double)curr.v);
            if(best[g[t.b][i].b][curr.v] > (best[t.b][curr.v] + curr.actl)) {
                best[g[t.b][i].b][curr.v] = best[t.b][curr.v] + curr.actl;
                put[g[t.b][i].b][curr.v] = put[t.b][curr.v];
                put[g[t.b][i].b][curr.v].push_back(t.b);
                //cout << "Dobavqme " << g[t.b][i].b << endl;
                k.push(curr);
            }
        }
    }
    int mn = 0;
    for(int i = 1; i < 600; i ++) {
        if(best[s][i] < 1000000)
//            cout << best[s][i] << " " << i << endl;
        if(best[s][i] < best[s][mn]) {
            mn = i;
        }
    }

    for(int i = 0; i < put[s][mn].size(); i ++) {
        cout << put[s][mn][i] << " ";
    }
    cout << s;
    return 0;

}

/*
4 4 3
0 1 1 1
1 0 1 1
1 2 1 1
2 3 1 1
*/

/*
4 4 3
0 1 1 1
1 2 1 1
0 2 2 1
2 3 2 1

*/


/*
6
15
1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
*/
