#include <iostream>
#include <queue>
using namespace std;
struct neshto{
    int speed;
    int lenght;
};
neshto graph[200][200];
int par[200], n, m, s;
double used[200];
const int INFINITY=1<<31-1;
void init()
{
    int inFrom, inTo, inLenght, inSpeed;
    cin>>n>>m>>s;
    for (int i=0; i<m; i++){
        cin>>inFrom>>inTo>>inSpeed>>inLenght;
        graph[inFrom][inTo].speed=inSpeed;
        graph[inFrom][inTo].lenght=inLenght;
    }
}
int traceSpeed(int to)
{
    if (to==-1) return 70;
    if (graph[par[to]][to].speed!=0) return graph[par[to]][to].speed;
    return traceSpeed(par[to]);
}
void djikstra()
{
    int qFront, lastPar;
    for (int i=0; i<n; i++) used[i]=INFINITY;
    queue <int> q;
    q.push(0);
    used[0]=0;
    par[0]=-1;
    while (q.size()!=0){
        qFront=q.front();
        for (int i=0; i<n; i++){
            if (i==qFront) continue;
            if (graph[qFront][i].lenght!=0){
                if (graph[qFront][i].speed!=0){
                    if (used[qFront]+(double)graph[qFront][i].lenght/graph[qFront][i].speed<used[i]){
                        q.push(i);
                        used[i]=used[qFront]+(double)graph[qFront][i].lenght/graph[qFront][i].speed;
                        par[i]=qFront;
                    }
                }
                else {
                    lastPar=par[i];
                    par[i]=qFront;
                    if (used[qFront]+(double)graph[qFront][i].lenght/traceSpeed(i)<used[i]){
                        q.push(i);
                        used[i]=used[qFront]+(double)graph[qFront][i].lenght/traceSpeed(i);
                        //cout<<par[i]<<" -> "<<i<<endl;
                    }
                    else par[i]=lastPar;
                }
            }
        }
        q.pop();
    }
}
void tracePar(int to)
{
    if (to!=-1){
        tracePar(par[to]);
        cout<<to<<" ";
    }
}
int main()
{
    init();
    djikstra();
    //cout<<traceSpeed(3)<<endl;
    tracePar(s);
    cout<<endl;

    return 0;
}
/**
6 15 1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
-------------------
6 8 4
0 2 10 100
0 3 2 100
0 4 1 100
1 4 0 150
5 1 8 64
2 3 4 36
3 4 2 80
3 5 5 25
-------------------
4 4 3
0 1 1 1
0 2 1 1
1 3 10 15
2 3 10 11
*/
