/*
First
*/
#include<iostream>
#include<vector>
#include<queue>
using namespace std;
int n, s, m;
int a, b;
double v, l, best_time;
int fastVel[256];

struct e
{
    int to;
    double time;
    double length;
    double velocity;
};

struct node
{
    double time;
    int curr;
    double velocity;
    queue<int> pred;

    bool operator<(node A) const{
        return this->time > A.time;
    }

};

vector<e> edge[256];
priority_queue<node> nex;
queue<int> best_queue;

bool fin[256][512];
//bool fin[256];

int main(){
    /*for(int i = 0; i < 250; i++){
        fastVel[i] = 0;
    }*/
    best_time = 123456789123;
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cin >> n >> m >> s;
    for(int i = 0; i < m; i++){
        cin >> a >> b >> v >> l;
        if(v != 0){
            double time = l/v;
            edge[a].push_back({b, time, l, v});
        }else{
            edge[a].push_back({b, 0, l, v});
        }
    }
    node p;
    p.time = 0;
    p.curr = 0;
    p.velocity = 70;
    queue<int> q;
    p.pred = q;
    nex.push(p);
    while(!nex.empty()){
        p = nex.top();
        nex.pop();
        if(p.curr == s && p.time < best_time){
            /*while(!p.pred.empty()){
                cout << p.pred.front() << " ";
                p.pred.pop();
            }
            cout << s << endl;
            cout << p.time;
            return 0;*/

            best_time = p.time;
            best_queue = p.pred;
        }
        int h = p.velocity;
        if(fastVel[p.curr] < h && !fin[p.curr][h]){
            fastVel[p.curr] = h;
            fin[p.curr][h] = true;
            for(int i = 0; i < edge[p.curr].size(); i++){
                e next_u = edge[p.curr][i];
                int vel = next_u.velocity;
                if(next_u.time < 0.00001 && !fin[next_u.to][vel]){
                    double t = next_u.length / p.velocity;
                    node f;
                    f.curr = next_u.to;
                    f.time = t + p.time;
                    f.velocity = next_u.velocity;
                    q = p.pred;
                    q.push(p.curr);
                    f.pred = q;
                    nex.push(f);
                }else{
                    node f;
                    f.curr = next_u.to;
                    f.time = p.time + next_u.time;
                    f.velocity = next_u.velocity;
                    q = p.pred;
                    q.push(p.curr);
                    f.pred = q;
                    nex.push(f);
                }
            }
        }
    }
    while(!best_queue.empty()){
        cout << best_queue.front() << " ";
        best_queue.pop();
    }
    cout << s << endl;
    //cout << p.time;
return 0;
}
/*
6 15 1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
*/
