#include<iostream>
#include<vector>
#include<queue>
using namespace std;
typedef  pair<int, double> Ipair;
vector<Ipair> v[152];
int m, n, s;
int V[152][152];
int L[152][152];
void dijkstra()
{
    int used[152];
    int time[152];
    for(int i=0;i<152;i++)
        {
            used[i]=0;
            time[i]=999999;
        }
    time[0]=0;
    priority_queue <Ipair, vector<Ipair>, greater <Ipair> > pq;
    pq.push(make_pair(time[0], 0)); /// time, index
    queue<int> way[152];
    way[0].push(0);
    while(!pq.empty())
    {
        int u=pq.top().second;
        pq.pop();
        if(used[u]==1) continue;
        used[u]=1;
        for(int i=0;i<v[u].size();i++)
        {
            int w=v[u][i].second;
            int current=v[u][i].first;
            if(time[current]>time[u]+w)
            {
                time[current]=time[u]+w;
                pq.push(make_pair(time[current], current));
                way[current]=way[u];
                way[current].push(u);
            }
        }
    }
    while(way[s].empty()==0)
    {
        cout<<way[s].front()<<" ";
        way[s].pop();
    }
}
int main()
{
    int a, b, v1, l;
    cin>>m>>n>>s;
    for(int i=0;i<n;i++)
    {
        cin>>a>>b>>v1>>l;
        double t;
        if(v1!=0) t=l/v1/1.0;
            else if(v1==0 && a==0)
                t=l/70.0;
            else t=-1;
        v[a].push_back(make_pair(b, t));
        V[a][b]=v1;
        L[a][b]=l;
        if(v1==0 && a==0) V[0][b]=70;
    }

    dijkstra();
    return 0;
}
/**
6 15 1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
*/
