#include<bits/stdc++.h>
using namespace std;

int Rvalue(char c){
    switch(c){
        case 'I':return 1;break;
        case 'V':return 5;break;
        case 'X':return 10;break;
        case 'L':return 50;break;
        case 'C':return 100;break;
        case 'D':return 500;break;
        case 'M':return 1000;break;
    }
    return -1;
}
int op(char c){
    switch(c){
        case '+':return 1;break;
        case '-':return 1;break;
        case '/':return 2;break;
        case '*':return 2;break;
    }
    return -1;
}

struct Wagon{
    string value;
    string type;
    bool negated=false;
    Wagon(){this->value="";this->type="";};
    Wagon(string t, string v){this->type=t;this->value=v;}
    void convert(){
        if(this->type=="Rnumber"){
            int n=0;
            int l=this->value.size();
            for(int i=0;i<l;i++){
                int j=i-1;
                while(Rvalue(this->value[i])>Rvalue(this->value[j])&&j>=0){
                    n-=2*Rvalue(this->value[j]);
                    j--;
                }
                n+=Rvalue(this->value[i]);
            }
            if(this->negated){n*=-1;}
            this->negated=false;
            this->value=to_string(n);
            this->type="number";
        }
    }
    void neg(){
        this->value=to_string(-stoi(this->value));
    }
};

Wagon train[2000];
int trainL=0;

Wagon polishTrain[2000];
int polishTrainL=0;

void removeWagon(int n){
    trainL--;
    for(int i=n;i<trainL;i++){
        train[i]=train[i+1];
    }
}

void outTrain(){
    for(int i=0;i<trainL;i++){
        cout<<"Wagon No "<<i<<" is: "<<train[i].value<<" with type: "<<train[i].type<<endl;
    }
}

void outPolishTrain(){
    for(int i=0;i<polishTrainL;i++){
        cout<<"Wagon No "<<i<<" is: "<<polishTrain[i].value<<" with type: "<<polishTrain[i].type<<endl;
    }
}

double calc(){
    stack<double> out;
    for(int i=0;i<polishTrainL;i++){
        if(polishTrain[i].type=="number"){
            out.push(double(stoi(polishTrain[i].value)));
        }else{
            double a=out.top();
            out.pop();
            double b=out.top();
            out.pop();
            double c;
            switch(polishTrain[i].value[0]){
                case '+':c=a+b;break;
                case '*':c=a*b;break;
                case '-':c=b-a;break;
                case '/':c=b/a;break;
            }
            out.push(c);
        }
    }
    return out.top();
}

int main(){
    string exp;
    cin>>exp;
     int l=exp.size();
    for(int i=0;i<l;i++){
        bool r=false;
        while(Rvalue(exp[i])!=-1){
            train[trainL].value+=exp[i];
            train[trainL].type="Rnumber";
            i++;
            r=true;
        }
        if(r){trainL++;}
        train[trainL].value=exp[i];
        switch(exp[i]){
            case '+':
            case '-':
            case '*':
            case '/':train[trainL].type="operator";break;
            case '(':train[trainL].type="open";break;
            case ')':train[trainL].type="close";break;
        }
        trainL++;
    }
    trainL--;
    for(int i=0;i<trainL;i++){
        train[i].convert();
        if(train[i].type=="operator"){
            if(i==0){
                removeWagon(i);
                train[i].negated=true;
                i--;
                continue;
            }
            if(train[i-1].type=="operator"){
                removeWagon(i);
                train[i].negated=true;
                i--;
                continue;
            }
        }
    }
    //outTrain();
    stack<Wagon>station;
    bool neg=false;
    for(int i=0;i<trainL;i++){
        if(train[i].type=="number"){
            polishTrain[polishTrainL++]=train[i];
            continue;
        }
        if(train[i].type=="operator"){
            while(!station.empty()&&op(station.top().value[0])>=op(train[i].value[0])){
                polishTrain[polishTrainL++]=station.top();
                station.pop();
            }
            station.push(train[i]);
        }
        if(train[i].type=="open"){
            station.push(train[i]);
        }
        if(train[i].type=="close"){
            while(station.top().type!="open"){
                polishTrain[polishTrainL++]=station.top();
                station.pop();
            }
            station.pop();
        }
    }
    while(!station.empty()){
        polishTrain[polishTrainL++]=station.top();
        station.pop();
    }
    //outPolishTrain();
    cout<<calc()<<endl;
}
//D-I+II-III+IV/II
